Codeforces Round 928 (Div. 4)(A、B、C、D、E、G)

这篇具有很好参考价值的文章主要介绍了Codeforces Round 928 (Div. 4)(A、B、C、D、E、G)。希望对大家有所帮助。如果存在错误或未考虑完全的地方,请大家不吝赐教,您也可以点击"举报违法"按钮提交疑问。

A

统计A、B输出

#include <bits/stdc++.h>
#define int long long
#define rep(i,a,b) for(int i = (a); i <= (b); ++i)
#define fep(i,a,b) for(int i = (a); i >= (b); --i)
#define pii pair<int, int>
#define ll long long
#define db double
#define endl '\n'
#define x first
#define y second
#define pb push_back

using namespace std;

void solve() {
	int cnt1=0,cnt2=0;
	string s;
	cin>>s;
	for(auto c:s){
		if(c=='A')	cnt1++;
		else cnt2++;
	}
	if(cnt1>=cnt2){
		cout<<"A"<<endl;
	}else{
		cout<<"B"<<endl;
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("1.in", "r", stdin);
	int _;
	cin>>_;
	while(_--)
	solve();
	return 0;
}

B

只需要判断正方形即可,不是正方形就是三角形。
正方形可以找到第一个行出现的1然后往下找,看是不是行列都是1

#include <bits/stdc++.h>
#define int long long
#define rep(i,a,b) for(int i = (a); i <= (b); ++i)
#define fep(i,a,b) for(int i = (a); i >= (b); --i)
#define pii pair<int, int>
#define ll long long
#define db double
#define endl '\n'
#define x first
#define y second
#define pb push_back

using namespace std;

void solve() {
	int n;
	cin>>n;
	string s[n];
	rep(i,0,n-1){
		cin>>s[i];
	}

	int xx=0,yy=0;
	rep(i,0,n-1){
		bool st=false;
		rep(j,0,n-1){
			if(s[i][j]=='1'){
				xx=i;
				yy=j;
				st=true;
				break;
			}
		}
		if(st){
			break;
		}
	}
//	cout<<xx<<' '<<yy<<endl;
	auto check=[&](int x,int y){
		for(int i=1;i+x<n&&y+i<n;++i){
			if(s[x+i][y]!=s[x][y+i]){
				return false;
			}
		}
		return true;
	};
	if(check(xx,yy)){
		cout<<"SQUARE"<<endl;
	}else{
		cout<<"TRIANGLE"<<endl;
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("1.in", "r", stdin);
	int _;
	cin>>_;
	while(_--)
	solve();
	return 0;
}

C

计算每个数字会出现的次数,乘起来就是答案。

#include <bits/stdc++.h>
#define int long long
#define rep(i,a,b) for(int i = (a); i <= (b); ++i)
#define fep(i,a,b) for(int i = (a); i >= (b); --i)
#define pii pair<int, int>
#define ll long long
#define db double
#define endl '\n'
#define x first
#define y second
#define pb push_back

using namespace std;

vector<int> get(int n) {
    vector<int> res(10, 0);
    if(!n) return res;
    if(n % 10 < 9) {
        res = get(n - 1);
        while(n) {
            res[n % 10]++;
            n /= 10;
        }
        return res;
    }
    res = get(n / 10);
    for(int i = 0; i < 10; i++) res[i] = res[i] * 10 + n / 10 + (i > 0);
    return res;
}

void solve() {
	int n;
	cin>>n;
	vector<int> ans = get(n);
	int res=0;
    for(int i = 1; i < ans.size(); i++) {
        res+=i*ans[i];
    }
    cout<<res<<endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("1.in", "r", stdin);
	int _;
	cin>>_;
	while(_--)
	solve();
	return 0;
}

D

用一个multiset存一下,之前的数按位取反的结果。
每次读进来之后在set里面查询,有的话直接删掉,没有的话插入就行。
每次删除会对答案造成-1的贡献。
之前的数按位取反有个简单的技巧:
异或上所有位都是1的数。参考jls的代码。

#include <bits/stdc++.h>
#define int long long
#define rep(i,a,b) for(int i = (a); i <= (b); ++i)
#define fep(i,a,b) for(int i = (a); i >= (b); --i)
#define pii pair<int, int>
#define ll long long
#define db double
#define endl '\n'
#define x first
#define y second
#define pb push_back

using namespace std;


void solve() {
	int n;
	cin>>n;
	
	multiset<int>s;
	int ans=n;
	auto change=[](int x){
		int ans=0;
		rep(i,0,30){
			int k=x&(1<<i);
			if(k){
			}else{
				ans|=(1<<i);
			}
		}	
		return ans;
	};
	rep(i,1,n){
		int val;
		cin>>val;
		if(s.count(val)){
			s.erase(s.find(val));
			ans--;
		}
		else s.insert(change(val));
	}
	cout<<ans<<endl;

}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("1.in", "r", stdin);
	int _;
	cin>>_;
	while(_--)
	solve();
	return 0;
}

Codeforces Round 928 (Div. 4)(A、B、C、D、E、G),codeforces,c语言,c++,算法,数据结构,spring boot,fastapi,django

E

赛时找到规律了,但是有个小细节没注意到导致没过
就是每个二次幂取的数是当前的 ( n + 1 ) 2 \frac{(n+1)}{2} 2(n+1)
然后n每次减半。
每个二次幂下都是一个等差数列

#include <bits/stdc++.h>
#define int long long
#define rep(i,a,b) for(int i = (a); i <= (b); ++i)
#define fep(i,a,b) for(int i = (a); i >= (b); --i)
#define pii pair<int, int>
#define ll long long
#define db double
#define endl '\n'
#define x first
#define y second
#define pb push_back

using namespace std;


void solve() {
	int n,k;
	cin>>n>>k;
	int cnt=0;
	while(k>(n+1)/2){
		k-=(n+1)/2;
		n/=2;
		cnt++;
	}
	cout<<((2*k-1)<<cnt)<<endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("1.in", "r", stdin);
	int _;
	cin>>_;
	while(_--)
	solve();
	return 0;
}

G

树上dp。
f [ u ] [ 0 ∣ 1 ] f[u][0|1] f[u][0∣1]:以u为根的为 S ∣ P S|P SP时的最小隔板数
转移
f [ u ] [ 0 ] + = m i n ( f [ v ] [ 0 ] , f [ v ] [ 1 ] + 1 ) ; f[u][0]+=min(f[v][0],f[v][1]+1); f[u][0]+=min(f[v][0],f[v][1]+1);
f [ u ] [ 1 ] + = m i n ( f [ v ] [ 1 ] , f [ v ] [ 0 ] + 1 ) ; f[u][1]+=min(f[v][1],f[v][0]+1); f[u][1]+=min(f[v][1],f[v][0]+1);文章来源地址https://www.toymoban.com/news/detail-832854.html


#include <bits/stdc++.h>
#define int long long
#define rep(i,a,b) for(int i = (a); i <= (b); ++i)
#define fep(i,a,b) for(int i = (a); i >= (b); --i)
#define pii pair<int, int>
#define ll long long
#define db double
#define endl '\n'
#define x first
#define y second
#define pb push_back

using namespace std;


void solve() {
	int n;
	cin>>n;
	vector<vector<int>>g(n+1);
	rep(i,2,n){
		int u;
		cin>>u;
		g[u].pb(i);
	}
	string s;
	cin>>s;
	vector<vector<int>>f(n+1,vector<int>(2));
	auto dfs=[&](auto &&dfs, int u)->void{
		f[u][0]=f[u][1]=0;
		if(s[u-1]=='S')	f[u][0]=1e9;
		if(s[u-1]=='P')	f[u][1]=1e9;
		for(auto v:g[u]){
			dfs(dfs,v);
			f[u][0]+=min(f[v][0],f[v][1]+1);
			f[u][1]+=min(f[v][1],f[v][0]+1);
		}
	};
	dfs(dfs,1);
	cout<<min({f[1][0],f[1][1]})<<endl;
	
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	freopen("1.in", "r", stdin);
	int _;
	cin>>_;
	while(_--)
	solve();
	return 0;
}

到了这里,关于Codeforces Round 928 (Div. 4)(A、B、C、D、E、G)的文章就介绍完了。如果您还想了解更多内容,请在右上角搜索TOY模板网以前的文章或继续浏览下面的相关文章,希望大家以后多多支持TOY模板网!

本文来自互联网用户投稿,该文观点仅代表作者本人,不代表本站立场。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如若转载,请注明出处: 如若内容造成侵权/违法违规/事实不符,请点击违法举报进行投诉反馈,一经查实,立即删除!

领支付宝红包 赞助服务器费用

相关文章

  • Codeforces Round 874 (Div. 3)

    用最少的长度为2的字符串按一定规则拼出s。规则是:前一个字符串的尾与后一个字符串的首相同。 统计s中长度为2的不同字符串数量。 给定数组a[n]和b[n],重排b后,令任意|ai−bi|≤k成立(1≤k≤n)数据保证一定有解。 将a和b分别按从小到大的顺序匹配便是最优的,一定能满足

    2024年02月05日
    浏览(36)
  • Codeforces Round 868 Div 2

    要求构造一个仅包含 (1) 和 (-1) 的长度为 (n) 的数组 (a) ,使得存在 (k) 个下标对 ((i, j), i j) 满足 (a_i times a_j = 1) 。 当有 (x) 个 (1) , (y) 个 (-1) 时,其满足条件的下标对数量为 (frac{x (x - 1)}{2} + frac{y (y - 1)}{2}) 。 由于 (n) 只有 (100) ,直接枚举 (x) 即可。

    2024年02月01日
    浏览(43)
  • Codeforces Round 871 (Div. 4)

    给定n个长度为10的字符串,问其与codeforces字符串的对应下标字母不同的个数。 对于每个字符串从前往后依次和“codeforces”对应字符比较然后统计不同字母数即可 给定长度为n的数组,问连续相邻为0的最大长度 维护一个全局最大长度res,和当前连续序列的长度cnt。从前往后扫

    2024年02月03日
    浏览(51)
  • Codeforces Round 867 (Div. 3)

    从所有a[i]+i-1=t的选择种取个max即可 实际上就是取同符号乘积的最大值 找规律,发现结果与边长n的关系是:res = n * (n + 3) - (n - 2) ①当n为奇数时,除了1其他均无解 ②当n为偶数时,我们可以构造一个形如n,1,n - 2,3,...的数列 首先我们可以发现n必定出现在起始位置。如果n不在起

    2024年02月02日
    浏览(45)
  • Codeforces Round 881 (Div. 3)

    给定一个数组,给每个元素涂色。求最大的代价。 代价为每个颜色的代价和。 每个颜色的代价为涂了该颜色的元素的极差。 因为是极差,每个元素要么对答案有正的贡献,要么有负的贡献,要么无贡献。且正负贡献的个数要相同。 因为要最大值,自然就是想有正贡献的是最

    2024年02月09日
    浏览(41)
  • Codeforces Round 912 (Div. 2)

    大等于2依据冒泡排序即可排序,因此判断下1即可 对每一个数字找哪一位肯定为0填0其他的填1 从后往前考虑加到当前集合或新立一个集合 从最高位开始考虑能否为1,计算能否时每个数当前位为1

    2024年02月04日
    浏览(43)
  • Codeforces Round 882 (Div. 2)

    目录 A. The Man who became a God  题目分析: B. Hamon Odyssey 题目分析: C. Vampiric Powers, anyone? 题目分析:  n个人分成k组,每一组的力量都是 这样的,那么如果分成k组那么就会有k-1个力量不被统计,将力量总和减去前k-1个最大的力量就是最小的结果   将数组分组,每个组内进行按位与

    2024年02月05日
    浏览(48)
  • Codeforces Round 894 (Div. 3)

    签到题 a数组里,大于等于前一个值的a[i]会被写到b里。直接遍历b,如果b[i]比前一个小就在它前面插一个相等的值 计算反过来的长度,判断是否相等就行 对于没有重复口味的集合,能选出的方案是n*(n-1)/2 (从n个里面选2个的组合数)。二分找出需要多少不同口味的冰淇淋,

    2024年02月11日
    浏览(43)
  • Codeforces Round 918 (Div. 4)补题

    Odd One Out(Problem - A - Codeforces) 题目大意:有三个数,其中两个相同,找出不同的那个数。 Not Quite Latin Square(Problem - B - Codeforces) 题目大意:有一个3*3的矩阵,每行每列都由1,2,3三个元素构成,且同行同列中的元素不同,先有一个地方出现空缺,要求输出空缺位置的元素

    2024年02月01日
    浏览(36)
  • Codeforces Round 875 (Div. 1) 题解

    You are given two arrays a and b both of length n. Your task is to count the number of pairs of integers ( i , j ) (i,j) ( i , j ) such that 1 ≤ i j ≤ n 1≤ij≤n 1 ≤ i j ≤ n and a i ⋅ a j = b i + b j a_i⋅a_j=b_i+b_j a i ​ ⋅ a j ​ = b i ​ + b j ​ 。 1 ≤ a i , b i ≤ n 1≤a_i,b_i≤n 1 ≤ a i ​ , b i ​ ≤ n 考虑 m i n ( a i

    2024年02月08日
    浏览(41)

觉得文章有用就打赏一下文章作者

支付宝扫一扫打赏

博客赞助

微信扫一扫打赏

请作者喝杯咖啡吧~博客赞助

支付宝扫一扫领取红包,优惠每天领

二维码1

领取红包

二维码2

领红包